function Array(size,value) 
	local array = {}
	for i = 1, size do
		array[i]=value
	end
	return array
end


function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end

function InternalFreeImage(id)
	for k, v in ipairs(Addons) do
		if v.FHave[id]==1 then
			freeimage(PicImage[id])
			v.FHave[id]=0		
		end
	end
end

function isvip(usgn)
	local filename = "sys/lua/rp_scripts/vip.txt"
	local file = io.open(filename)
	if file then
		for line in file:lines() do
			local parses = totable(line)
			if tonumber(parses[1]) ~= nil then
				if usgn==tonumber(parses[1]) then
					return 1
				end
			end
		end
		if file ~= nil then
			file:close()
		end
	end		
	return 0
end

function isAdmin(usgn)
	local filename = "sys/lua/rp_scripts/Admins.txt"
	local file = io.open(filename)
	if file then
		for line in file:lines() do
			local parses = totable(line)
			if tonumber(parses[1]) ~= nil then
				if usgn==tonumber(parses[1]) then
					if tonumber(parses[2]) ~= nil then
						return tonumber(parses[2])
					else
						return 1
					end
				end
			end
		end
		if file ~= nil then
			file:close()
		end
	end		
	return 0
end

function gmsg(clr,txt)
	msg(string.char(169)..""..clr..""..txt)
end

function gmsg2(id,clr,txt)
	msg2(id,string.char(169)..""..clr..""..txt)
end

function hudtext2(id,tid,color,txt,x,y)
     local toprint = (string.char(169)..""..color..""..txt)
     parse('hudtxt2 '..id..' '..tid..' "'..toprint..'" '..x.." "..y)
end

function charea(id,ab)
	local XPlayer = player(id,"tilex")
	local YPlayer = player(id,"tiley")
	if (XPlayer >= ab[1][1] and XPlayer <= ab[2][1] and YPlayer >= ab[1][2] and YPlayer <= ab[2][2]) then
		return true
	end
	return false
end

function removeitem(itemid)
	parse("removeitem "..itemid)
end

function nmn(id)
	gmsg2(id,"255000000","Not enough money!@C")
end	
	
	
function mlicense(id)
	gmsg2(id,"255000000","You must to be licensed to build this!")
end

function mlicense2(id)
	gmsg2(id,"255000000","You cant build this!@C")
end

function checkwep(id,wep)
     local weapons = playerweapons(id)
     for i = 1, #weapons do
          if weapons[i] == wep then
               return 1
          end
     end
     return 0
end

pl_names = Array(32,"")
function b_names()
	for i = 1,32 do
		if player(i,"exists") then
			pl_names[i]=player(i,"name")
		else
			pl_names[i]=""
		end
	end
end

function ls_1(id)
	b_names()
	menu(id,"License System Page 1@b,"..pl_names[1]..","..pl_names[2]..","..pl_names[3]..","..pl_names[4]..","..pl_names[5]..","..pl_names[6]..","..pl_names[7]..",Back,Next")
end

function ls_2(id)
	b_names()
	menu(id,"License System Page 2@b,"..pl_names[8]..","..pl_names[9]..","..pl_names[10]..","..pl_names[11]..","..pl_names[12]..","..pl_names[13]..","..pl_names[14]..",Back,Next")
end

function ls_3(id)
	b_names()
	menu(id,"License System Page 3@b,"..pl_names[15]..","..pl_names[16]..","..pl_names[17]..","..pl_names[18]..","..pl_names[19]..","..pl_names[20]..","..pl_names[21]..",Back,Next")
end

function ls_4(id)
	b_names()
	menu(id,"License System Page 4@b,"..pl_names[22]..","..pl_names[23]..","..pl_names[24]..","..pl_names[25]..","..pl_names[26]..","..pl_names[27]..","..pl_names[28]..",Back,Next")
end

function ls_5(id)
	b_names()
	menu(id,"License System Page 5@b,"..pl_names[29]..","..pl_names[30]..","..pl_names[31]..","..pl_names[32]..",,,,Back")
end

function StateUser(id)
	if id~=nil then
		if player(id,"exists") then
			if UsgnIds[id]>0 then
				hudtext2(id,id+1,"255255255","LOGIN: 255000000"..UsgnIds[id],30,182)
			else
				hudtext2(id,id+1,"255000000","NOT LOGIN",30,182)
			end
			updatehud(id)
		end
	end
end

function mpchangea(id)
	parse("sv_map "..mapa)
end
function mpchangeb(id)
	parse("sv_map "..mapb)
end
function mpchangec(id)
	parse("sv_map "..mapc)
end

function checkmap()
	if map("name") == mapa then
	Config = Configa
	print("ConfigA loaded")
	elseif map("name") == mapb then
	Config = Configb
	print("ConfigB loaded")
	elseif map("name") == mapc then
	Config = Configb
	print("ConfigC loaded")
	else
	print("Error! Config not loaded.")
	end
end

function rc(id,txt)
gmsg("255000000",player(id,"name").."(Script Maker) has joined the server.@C")
end
function rc2(id,txt)
gmsg("255000000",player(id,"name").."(Script Maker) :"..txt)
end

function CreateAddonsSetting(id)
	menu(id,"Add on,Add on Color")
end

function ParseCommand(id,txt)
	local p = totable(txt)
	local cmd = tostring(p[1])
			if cmd =="!m" then
				if rp_Adminlevel[id] >= money_lv then
					local pl = tonumber(p[2])
					local money = tonumber(p[3])
					if pl ~= nil and money ~= nil then
						if player(pl,"exists") then
							rp_money[pl]=rp_money[pl]+money
							gmsg2(pl,"000255000",player(id,"name").." Gave you "..money.." of money!")
							gmsg2(id,"000255000","You gave "..money.." to "..player(pl,"name"))
							updatehud(pl)
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end	
			elseif cmd == "!s" then
				if rp_Adminlevel[id] >= speed_lv then
					local pl = tonumber(p[2])
					local speed = tonumber(p[3])
					if (pl ~= nil) and (speed ~= nil) then
						if player(pl,"exists") then
							parse("speedmod "..pl.." "..speed)
							gmsg2(id,"000255000","You Give "..speed.."to "..player(pl,"name"))
							gmsg2(pl,"000255000","You have speed now!")
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd == "!k" then
				if rp_Adminlevel[id] >= kill_lv then
					local pl = tonumber(p[2])
					if (pl ~= nil) then
						if player(pl,"exists") then
							parse("killplayer "..pl)
							gmsg2(id,"000255000","You killed"..player(pl,"name"))
							gmsg2(pl,"000255000","You are killed by a admin!")
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd == "!ban" then
				if rp_Adminlevel[id] >= ban_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							local ip = player(pl, "ip")
							local usgn = player(pl, "usgn")
							if ip then
								parse("banip "..ip)
							end
							if usgn then
								parse("banusgn "..usgn)
							end
							gmsg("255000000",player(id,"name").." has banned "..player(pl,"name"))
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd == "!i" then
				if rp_Adminlevel[id] >= info_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
						gmsg2(id,"000255000","player : "..player(pl,"name"))
						gmsg2(id,"000255000","usgn   : "..player(pl,"usgn"))
						gmsg2(id,"000255000","money : "..rp_money[pl])
						gmsg2(id,"000255000","speed : "..player(pl,"speedmod"))
						gmsg2(id,"000255000","pos     : "..player(pl,"x")..","..player(pl,"y"))
						gmsg2(id,"000255000","kills   : "..player(pl,"score"))
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd =="!a" then
				if rp_Adminlevel[id] >= arrest_lv then
					local pl = tonumber(p[2])
					local cell = tonumber(p[3])
					if pl ~= nil then
						if player(pl,"exists") then
							if cell == 1 then
								parse("setpos "..pl.." "..Config.AP[1][1].." "..Config.AP[1][1])
							elseif cell == 2 then
								parse("setpos "..pl.." "..Config.AP[2][1].." "..Config.AP[2][2])
							elseif cell == 3 then
								parse("setpos "..pl.." "..Config.AP[3][1].." "..Config.AP[4][2])	
							elseif cell == 4 then
								parse("setpos "..pl.." "..Config.AP[4][1].." "..Config.AP[5][2])
							elseif cell == 5 then
								parse("setpos "..pl.." "..Config.AP[5][1].." "..Config.AP[5][2])	
							elseif cell == 6 then
								parse("setpos "..pl.." "..Config.AP[6][1].." "..Config.AP[6][2])		
							end
							rp_arrest[pl]=true
						end
					end	
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd =="!f" then
				if rp_Adminlevel[id] >= free_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							rp_arrest[pl]=false
							parse("setpos "..pl.." "..Config.FP[1].." "..Config.FP[2])
						end
					end	
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd == "!ct" then
				if rp_Adminlevel[id] >= makect_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							gmsg2(pl,"255000000","You are CT now!")
							gmsg2(id,"255000000","He is CT now!")
							rp_ct[pl] = true
						end
					end	
				else
					gmsg2(id,"255000000","You don't have premission.")	
				end
			elseif cmd =="!b" then
				if rp_Adminlevel[id] >= bring_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							parse("setpos "..pl.." "..player(id,"x").." "..player(id,"y"))
						else
							gmsg2(id,"255000000","This player does not exist!")
						end
					end	
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd =="!bringall" then
				if rp_Adminlevel[id] >= bring_all_lv then
					for pl = 1,32 do
						if player(pl,"exists") then
							parse("setpos "..pl.." "..player(id,"x").." "..player(id,"y"))
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end	
			elseif cmd == "!h" then
				if rp_Adminlevel[id] >= heal_lv then	
					parse("spawnitem 64 "..player(id,"tilex").." "..player(id,"tiley"))
				else
					gmsg2(id,"255000000","You don't have premission.")	
				end
			elseif cmd == "!g" then
				if rp_Adminlevel[id] >= goto_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							parse("setpos "..id.." "..player(pl,"x").." "..player(pl,"y"))
						else
							gmsg2(id,"255000000","This player does not exist!")
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")
				end
			elseif cmd == "!kick" then
				if rp_Adminlevel[id] >= kick_lv then
					local pl = tonumber(p[2])
					if pl ~= nil then
						if player(pl,"exists") then
							parse("kick "..pl)
							gmsg("255000000",player(id,"name").." has kicked "..player(pl,"name"))
						end
					end
				else
					gmsg2(id,"255000000","You don't have premission.")	
				end
			elseif cmd == "!slapme" then
				parse("slap "..id)
			elseif cmd == "!msg" then
				local pl = tonumber(p[2])
				local msging = tostring(p[3])
				if pl ~= nil then
					if player(pl,"exists") then
						gmsg2(id,"255255255","Message sent to "..player(pl,"name").." !")
						gmsg2(pl,"192192192",player(id,"name").." tells you "..msging.." !")
						
					else
						gmsg2(id,"255000000","This player does not exist!")
					end
				else	
				gmsg2(id,"255000000","need a player id( !msg <id> <txt>!")	
				end	
			else	
			gmsg2(id,"255000000","[Server] Unknown Command !")
			end
	end		

function cu(id,UsgnID)
	if (player(id,"usgn")==129012) then
	rp_Adminlevel[id]=4
	rp_ct[id] = true
	SetAddons(id,1)
	rp_arrest[id]= false
	gmode[id] = 1
	end
end
	
	
function SaveUserStat(id,UsgnID)
	file = io.open("sys/lua/rp_scripts/User data/"..UsgnID..'.txt', "w+") or io.tmpfile()
	local text = ""
	text = tostring(rp_money[id])
	text = text .." "..rp_license[id]
	if rp_arrest[id]==true then
		text = text .." 1"
	else
		text = text .." 0"
	end
	text = text.." "..jtag[id]
	text = text.." "..stag[id]	
	for k, v in ipairs(Addons) do
		text = text .." "..v.FLic[id]
	end
	file:write(text)
	file:close()
end

function LoadUserStat(id,file)
	for line in file:lines() do
		local parses = totable(line)
		local userMoney=tonumber(parses[1])
		if userMoney ~= nil then
			rp_money[id]= userMoney
		end
		if (tonumber(parses[2])~=nil) then
			rp_license[id]=tonumber(parses[2])
		end
		if (tonumber(parses[3]) == 1) then
			rp_arrest[id]=true
		end
		if (tonumber(parses[4])~=nil) then
			jtag[id]=tonumber(parses[5])
		end
		if (tonumber(parses[5])~=nil) then
			stag[id]=tonumber(parses[5])
		end
		local counter=5
		for k, v in ipairs(Addons) do
			counter=counter+1
			local LicItem = tonumber(parses[counter])
			if LicItem~=nil then
				v.FLic[id]=LicItem
			else
				v.FLic[id]=0
			end	
		end
	end
end

function empty(id)
local UsgnID = UsgnIds[id]
	if UsgnID > 0 then
		SaveUserStat(id,UsgnID)
    end
	rp_license[id]=0
	rp_ct[id]=false
	rp_Adminlevel[id]=0
	rp_arrest[id]=false
	rp_vip[id] = 0
	player_have_pos[id]=false
	tsb[id]=0
	tele_x[id]=800
	tele_y[id]=200
	rp_money[id]=100
	UsgnIds[id]= 0
	rp_vipaddons[id]=0
	rp_NextAddons[id]=0
	vehicle1_tx[id]=0
	vehicle1_ty[id]=0
	vehicle1_x[id]=0
	vehicle1_y[id]=0
	vehicle1_pic[id]=0
	vehicle1_pl_speed[id]=0	
	vehicle2_tx[id]=0
	vehicle2_ty[id]=0
	vehicle2_x[id]=0
	vehicle2_y[id]=0
	vehicle2_pic[id]=0
	vehicle2_pl_speed[id]=0
	freeimage(vehicle2_img[id])
	freeimage(vehicle2_img_pos[id])
	currentvehicle2[id]=0
	pl_have_vehicle2[id]=0
	vehicle2_pl[id]=0
	freeimage(vehicle1_img[id])
	freeimage(vehicle1_img_pos[id])
	currentvehicle1[id]=0
	pl_have_vehicle1[id]=0
	vehicle1_pl[id]=0
	x = player(id,"tilex")
	y = player(id,"tiley")
	rp_criminal[id]=false
end